package org.apache.bcel.generic;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.StringTokenizer;
import org.apache.bcel.Const;
import org.apache.bcel.classfile.Constant;
import org.apache.bcel.classfile.ConstantCP;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.Utility;
import org.apache.bcel.generic.ConstantPoolGen;
import org.apache.bcel.generic.ExceptionThrower;
import org.apache.bcel.generic.FieldOrMethod;
import org.apache.bcel.generic.StackConsumer;
import org.apache.bcel.generic.StackProducer;
import org.apache.bcel.generic.Type;

public abstract class InvokeInstruction extends FieldOrMethod implements ExceptionThrower, StackConsumer, StackProducer {
  InvokeInstruction() {}
  
  protected InvokeInstruction(short opcode, int index) {
    super(opcode, index);
  }
  
  public int consumeStack(ConstantPoolGen cpg) {
    int sum;
    if (getOpcode() == 184 || getOpcode() == 186) {
      sum = 0;
    } else {
      sum = 1;
    } 
    String signature = getSignature(cpg);
    sum += Type.getArgumentTypesSize(signature);
    return sum;
  }
  
  public Type[] getArgumentTypes(ConstantPoolGen cpg) {
    return Type.getArgumentTypes(getSignature(cpg));
  }
  
  public String getClassName(ConstantPoolGen cpg) {
    ConstantPool cp = cpg.getConstantPool();
    ConstantCP cmr = (ConstantCP)cp.getConstant(getIndex());
    String className = cp.getConstantString(cmr.getClassIndex(), (byte)7);
    return Utility.pathToPackage(className);
  }
  
  public String getMethodName(ConstantPoolGen cpg) {
    return getName(cpg);
  }
  
  public Type getReturnType(ConstantPoolGen cpg) {
    return Type.getReturnType(getSignature(cpg));
  }
  
  public Type getType(ConstantPoolGen cpg) {
    return getReturnType(cpg);
  }
  
  public int produceStack(ConstantPoolGen cpg) {
    String signature = getSignature(cpg);
    return Type.getReturnTypeSize(signature);
  }
  
  public String toString(ConstantPool cp) {
    Constant c = cp.getConstant(getIndex());
    StringTokenizer tok = new StringTokenizer(cp.constantToString(c));
    String opcodeName = Const.getOpcodeName(getOpcode());
    StringBuilder sb = new StringBuilder(opcodeName);
    if (tok.hasMoreTokens()) {
      sb.append(" ");
      sb.append(tok.nextToken().replace('.', '/'));
      if (tok.hasMoreTokens())
        sb.append(tok.nextToken()); 
    } 
    return sb.toString();
  }
}
